﻿/*
 MoveFolder.js
 ・履歴
 ver 2.5		2015/02/02 [変更点：prototype.jsを使わなくても動くように修正できていなかったので再修正]
 ver 2.4		2013/10/29 [変更点：prototype.jsを使わなくても動くように修正]
 ver 2.3		2012/04/01 [変更点：onlyDisplayThumb設定追加。usePopThumb設定変更(popThumb_FAが使用されてたら自動ON・デフォOFF)]
 ver 2.2		2012/01/06 [変更点：usePopThumb設定追加。従来のサムネ画像だけ→falseに。]
 ver 2.1		2011/08/11 [変更点：mylistでは、リストの動画に対して検索]
 
 ・機能
 ニコニコ動画内でそのページにあるリンク（サムネ有りのみ）のうち、cacheがあるものを表示
 →個別 or 一括でフォルダ移動可能 & cacheファイル名変更可能
 
 ・使い方
 localフォルダにこのjsファイルをおいて、以下のnlFilterを導入
 
 
[Replace]
Name = MoveFolder:jsリンク追加(watch以外)
URL = www.nicovideo.jp/(?!watch)
Match<
<span id="nlbar">
>
Replace<
$0 |
<a href="javascript:void(0)" onclick="NicoCacheMove.togglePanel();">Move</a>
<script type="text/javascript" charset="utf-8" src="http://www.nicovideo.jp/$TS(local/MoveFolder.js)"></script>
<style type="text/css">
tr.NCM_checked { background-color: LightCyan; }
</style>
>
 
 
 ・注意事項
 初回のFlvlistの受信は時間がかかります。２回目以降（ページを移動しても）はすぐ受信できるので快適です。
 一度表示された後は、「Folder」をクリックしてもパネルの表示/非表示の切り替えのみ
 mylistやAutoPagerでの再取得(表示動画を変えた場合)は[更新]をクリック
 タイトル部分を右クリックでcacheファイル名変更可能
 
 //*/
(function () {
	window.NicoCacheMove = {
		//	全キャッシュの情報を受信してキャッシュの有無を確認するかどうか	falseならajax_infoでそれぞれ取得
		//	※falseの場合ページ内サムネの数が多ければ多いほど遅くなりますが、
		//		キャッシュがあまりにも多い人は、全キャッシュの情報を受信よりは早いかもしれません。
		//			ただし、非同期でやるので、cacheの有無の確認が終わるまでページの操作ができません。
		//	※ useFlvlist:true 推奨
		useFlvlist: true,
		//デフォルトのcacheフォルダの名前（表示のみ・デフォルトだと空白[""]でわかりにくいため）
		defaultFolderName: '#cache',
		// 動画IDにマウスを乗せるとpopThumb.jsで詳細を表示する(true) / サムネのみ(false)
		// ※ popThumbが使われてない場合は自動でfalseになります。
		usePopThumb: true,
		// 表示中のサムネのみ対象とする。 
		onlyDisplayThumb:true,

		size: function(){
			return Math.round((window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight) * 90 / 100);
		},
		//操作用パネル表示/非表示
		togglePanel: function () {
			if (this.withCacheSearch) {
				if (this.ControlPanel && this.ControlPanel.visible()){
					this.ControlPanel.hide();
				} else {
					if (this.data && this.data.dirList) {
						this.getCached();
						this.makePanel();
					} else {
						this.load();
					}
				}
				return;
			}
			if (this.ControlPanel) {
				this.ControlPanel.toggle();
				this.resize();
			} else {
				if (this.data && this.data.dirList) {
					this.getCached();
					this.makePanel();
				} else {
					this.load();
				}
			}
		},
		showThumbImg: function (smid, n, e) {
			if (this.usePopThumb) {
				popThumb("thumb/" + smid);
			} else {
				var id = smid.substring(2);
				var el = $(this.table).getElementsByClassName('NCM_Img')[n];
				if(el.src.match(/res/)) el.src = 'http://tn-skr' + (id % 4) + '.smilevideo.jp/smile?i=' + id;
				e = e || window.event;
				el.style.left = e.clientX - 135 + 'px';
				el.style.top = ((e.clientY - 100 < 0) ? e.clientY : e.clientY - 100 ) + 'px';
				el.show();
			}
		},
		hideThumbImg: function (n) {
			if (this.usePopThumb) {
				nd();
			} else {
				$(this.table).getElementsByClassName('NCM_Img')[n].hide();
			}
		},
		//移動
		move: function (smid, only_top, elm, byALL) {
			var self = this;
			var folder_name = this.data.dirList[this.folderNow];
			if (only_top) {
				var url = '/cache/ajax_topmove';
			} else {
				var url = '/cache/ajax_move';
			}
			new Ajax.Request(url, {
				method: 'GET',
				parameters: smid + '-' + encodeURI(folder_name),
				asynchronous: true,
				onComplete: function (xhr) {
					if (xhr.responseText == 'OK') {
						if (folder_name == '') {
							folder_name = self.defaultFolderName;
						}
						if (self.useFlvlist) {
							// パネルの表示を更新
							var nextElm_Child_P = elm.parentNode.nextSibling.getElementsByTagName('p')[0];
							nextElm_Child_P.title = folder_name;
							nextElm_Child_P.replaceChild(document.createTextNode(folder_name), nextElm_Child_P.firstChild);
							// Flvlistの情報を更新
							self.updateCacheList(smid, 1, folder_name);
						}
						var text = '[' + folder_name + ']に移動しました';
						
						// 表示データ更新
						if (self.withCacheSearch) {
							if (byALL) {
								self.allMove_count++;
								if (self.num_nowSeleted === self.allMove_count) {
									window.updateShowingMyList();
								}
							} else {
								window.updateShowingMyList();
							}
						}
					} else {
						var text = '失敗しました(cache直下になかった等)';
					}
					elm.value = xhr.responseText;
					elm.title = text;
				}
			});
		},
		allMove_count:0,
		//全移動
		allMove: function (only_top) {
			var smid = this.smid_cached;
			var check = $(this.table).getElementsByClassName('NCM_checkbox');
			var button = $(this.table).getElementsByClassName('NCM_moveButton');
			var byALL = true;
			this.allMove_count = 0;
			for (var i = 0, len = smid.length; i < len; ++i) {
				if(check[i].checked) {
					this.move(smid[i][0], only_top, button[i], byALL);
				}
			}
		},
		getData: function (func) {
			//キャッシュディレクトリなどのデータ
			this.data = {};
			var self = this;
			if (this.useFlvlist && !this.withCacheSearch) {
				new Ajax.Request('/cache/flvlist.json', {
					method: 'GET',
					asynchronous: true,
					onComplete: function (xhr, json) {
						self.data = (json) ? json : xhr.responseText.evalJSON();
						if(typeof func === 'function') func();
					}
				});
			} else {
				new Ajax.Request('/cache/dirlist.json', {
					method: 'GET',
					asynchronous: true,
					onComplete: function (xhr, json) {
						self.data.dirList = (json) ? json : xhr.responseText.evalJSON();
						if(typeof func === 'function') func();
					}
				});
			}
		},
		// Flvlistの情報を更新(Flvlist使用時)
		updateCacheList: function (smid, num, newData) {
			if (this.withCacheSearch) {
				// window.updateDataList : cacheSearch.htmlに存在
				if (num === 0) {
					window.updateDataList(smid, "title", newData);
					window.updateShowingMyList();
				} else if (num === 1) {
					window.updateDataList(smid, "folder", newData);
					window.updateDataList(smid, "description", newData);
				}
				return;
			}
			if (this.useFlvlist) {
				var cacheList = this.data.cacheList;
				if (cacheList[smid]) {
					cacheList[smid][num] = newData;
				} else {
					cacheList[smid + 'low'][num] = newData;
				}
			}
		},
		getLink: function () {
			//ページ内にあるsmid(サムネのリンクの方)の配列
			var smid_inPage = [];
			if (location.pathname.indexOf("/mylist/") === 0){
				var items = window.my.currentItems;
				for (var i = 0, len = items.length; i< len; i++){
					smid_inPage.push(items[i].item_data.watch_id);
				}
			} else {
				//ページ内にあるsmidがすでにあるかの確認用
				var smid_inPage_check = {};
				var elms = document.getElementsByTagName('a');
				for (var i = 0, len = elms.length; i < len; ++i) {
					var elm_a = elms[i];
					if (elm_a.getElementsByTagName('img').length && elm_a.href && elm_a.href.match(/watch\/([a-z]{2}\d+)/)) {
		//				if (this.onlyDisplayThumb && elm_a.getElementsByTagName('img')[0].clientWidth === 0) continue;
						var smid = RegExp.$1;
						if (!smid_inPage_check[smid]) {
							smid_inPage.push(smid);
							smid_inPage_check[smid] = true;
						}
					}
				}
			}
			return smid_inPage;
		},
		// cacheSearch.htmlで仕様中か否か
		withCacheSearch: false,
		getCached: function (all) {
			//キャッシュ済みでページ内にあるsmidの配列
			this.smid_cached = [];
			if (this.useFlvlist && all) {
				var cacheList = this.data.cacheList;
				for(var key in cacheList) {
					this.smid_cached.push([key, cacheList[key][0], cacheList[key][1]]);
				}
				return;
			} 
			if (this.withCacheSearch) {
				var items = window.my.currentItems;
				for (var i = 0, len = items.length; i< len; i++){
					// description == folder
					this.smid_cached.push([items[i].watch_id, items[i].title, items[i].description]);
				}
				return;
			}
			var smid = this.getLink();
			if (smid.length) {
				if (this.useFlvlist) {
					var cacheList = this.data.cacheList;
					for (var i = 0, len = smid.length; i < len; ++i) {
						var List = (cacheList[smid[i]] || cacheList[smid[i] + 'low']);
						if (List) {
							this.smid_cached.push([smid[i], List[0], List[1]]);
						}
					}
				} else {
					var self = this;
					for (var i = 0, len = smid.length; i < len; ++i) {
						new Ajax.Request('/cache/ajax_info?' + smid[i], {
							method: 'GET',
							asynchronous: false,
							onComplete: function (xhr) {
								if (xhr.responseText && xhr.responseText.match(/^OK(?:,[^,]*){3},0,(.*)$/)) {
									self.smid_cached.push([smid[i], RegExp.$1]);
								}
							}
						});
					}
				}
			}
		},
		//操作用パネル作成
		makePanel: function () {
			if (this.ControlPanel) {
		//		Element.remove(this.ControlPanel);
				$(this.ControlPanel).remove();
			}
			this.ControlPanel = $(MakeElement(document.body, ['div', [
				['style.display', 'block'],
				['style.zIndex', '9999'],
				['style.position', 'fixed'],
				['style.top', '50%'],
				['style.left', '50%'],
				['style.marginTop', '-' + this.size() / 2 + 'px'],
				['style.marginLeft', '-45%'],
				['style.height', this.size() + 'px'],
				['style.width', '90%'],
				['style.textAlign', 'left'],
				['style.background', 'white'],
				['style.border', 'solid 2px black']
			]]));
			this.appendPanelTop();
		},
		num_nowSeleted:0,
		allMoveButtonUpdate: function(){
			var n = 0;
			var elm = $(this.table).getElementsByClassName('NCM_checkbox');
			for(var i = 0, len = elm.length; i < len; i++){
				if(elm[i].checked) n++;
			}
			this.allMoveButton.value = '選択中 (' + n + '個) を移動';
			this.num_nowSeleted = n;
		},
		appendPanelTop: function () {
			if (this.top) {
		//		Element.remove($(this.top));
				$(this.top).remove();
			}
			//フォルダ移動先セレクトボックスでの選択中
			this.folderNow = 0;
			var smid = this.smid_cached;
			var self = this;
			var top = document.createElement('div');

			this.allMoveButton = MakeElement(top, ['input', [
				['type', 'button'],
				['value', '以下の選択中動画 (' + this.smid_cached.length + '個) を移動'],
				['title', '左クリックでcache直下のファイルのみ対象 \r\n/ 右クリックで全キャッシュフォルダ対象'],
				['onclick', function () {
					self.allMove(true); // onlyTop = true
				}],
				['oncontextmenu', function () {
					self.allMove(false);// onlyTop = false
					return false;
				}]
			]]);
			var folderSelect = MakeElement(top, ['select', [
				["title", 'すべての移動で、このセレクトボックスでの選択中のフォルダへ移動します。'],
				['onchange', function () {
					self.folderNow = this.value;
				}]
			]]);
			var optionList = [];
			for (var i = 0, len = this.data.dirList.length; i < len; ++i) {
				optionList[i] = MakeElement(folderSelect, ['option', ["value", String(i)],
					[true, (i ? this.data.dirList[i] : this.defaultFolderName)]
				]);
			}
	//		top.appendChild(folderSelect);
			
			// フォルダも検索できるようにした
			var box_sf = MakeElement(top, ['input', [
				['type', 'text'],
				['style.marginLeft', '10px'],
				["title", "フォルダを検索"],
				["placeholder", "フォルダを検索"],
				['onkeydown', function (event) {
					if (event.keyCode !== 13) return true;
					var word = box_sf.value.replace(/(^[\s　]+)|([\s　]+$)/g, "");
					var count = 0;
					for (var i = 0, len = self.data.dirList.length; i < len; i++) {
						var option = optionList[i];
						var parent = option.parentNode;
						if (self.data.dirList[i].match(word) || 0 === i) {
							count++;
							if(parent.tagName === "SPAN") {
								parent.parentNode.replaceChild(option, parent);
							}
						} else {
							// optionをdisplay:noneにしてもselectの表示がおかしいので、spanで囲ってそれを隠す
							if(parent.tagName === "SELECT") {
								var span = document.createElement("span");
								parent.replaceChild(span, option);
								span.style.display = "none";
								span.appendChild(option);
							}
						}
					}
					matchedFolderCount.innerHTML = (count - 1) + "/" + self.data.dirList.length;
				}]
			]]);
			
			var matchedFolderCount = MakeElement(top, ['span', [
				[true, self.data.dirList.length + "/" + self.data.dirList.length]
			]]);
			// ここまで

			//	閉じるボタン	一番右上に置くために最初にfloat:right
			//	AllCacheボタン	useFlvlist使用時
			//	更新ボタン
//			var isIE = Prototype.Browser.IE;
			var isIE = !!(window.attachEvent && !window.opera);
			this.top = MakeElement(this.ControlPanel, [top, [],
				['input', [
					['type', 'button'],
					['value', '閉じる'],
					[(isIE ? 'style.styleFloat' : 'style.cssFloat'), 'right'],
					["onclick", function () {
						self.ControlPanel.hide();
					}]
				]],
				[this.useFlvlist && !this.withCacheSearch ? 'input' : 0, [
					['type', 'button'],
					['value', 'AllCache'],
					['title', 'すべてのキャッシュを表示\n※注意！激重'],
					[(isIE ? 'style.styleFloat' : 'style.cssFloat'), 'right'],
					["onclick", function () {
						self.getCached(true);
						self.appendPanelTable();
						self.allMoveButtonUpdate();
					}]
				]],
				[!this.withCacheSearch ? 'input' : 0, [
					['type', 'button'],
					['value', '更新'],
					['title', 'クリック=ページ内の情報に対して更新。\r\n右クリック=NicoCacheの[キャッシュ情報・ディレクトリ情報]も更新。'],
					[(isIE ? 'style.styleFloat' : 'style.cssFloat'), 'right'],
					["onclick", function () {
						self.getCached();
						self.appendPanelTable();
						self.allMoveButtonUpdate();
					}],
					["oncontextmenu", function(){
						self.getData(function () {
							self.getCached();
							self.appendPanelTop();
						});
						return false;
					}]
				]],
				['input', [
					['type', 'text'],
					['title', '動画をID及び保存ファイル名で検索\nエンターで検索実行\n空白でもとに戻す'],
					[(isIE ? 'style.styleFloat' : 'style.cssFloat'), 'right'],
					["onkeydown", function (event) {
						self.filterVideos(event, this);
					}]
				]]
			]);
			this.appendPanelTable();
			this.allMoveButtonUpdate();
		},
		appendPanelTable: function () {
			var self = this;
			if (this.table) {
			//	Element.remove($(this.table));
				$(this.table).remove();
			}
			var smid = this.smid_cached;


			var tbody = document.createElement('tbody');
			this.table = MakeElement(this.ControlPanel, ['div', [
				['style.overflow', 'auto'],
				['style.height', this.ControlPanel.offsetHeight - $(this.top).offsetHeight - 5 + 'px']
			],
				['table', ['style.tableLayout', 'fixed', 'style.overflow', 'auto'],
					[tbody]
				]
			]);

			var help = MakeElement(tbody, ['tr', [],
				['td', ['style.textAlign', 'center', 'title', '全切り替え\r\nShift押しながらで一括選択できます。'],
					['input', [
						['type', 'checkbox'],
						['checked', true],
						['onclick', function(){
							var check = this.checked;
							$A($(self.table).getElementsByClassName('NCM_checkbox')).each(function(box){
								if (!box.hasClassName("NCM_hidden")) {
									box.checked = check;
									box.parentNode.parentNode.className = check ? "NCM_checked" : "";
								}
							});
							self.allMoveButtonUpdate();
						}]
					]]
				],
				['td', [
					[true, '個別'],
					['title', '個別移動用ボタン\r\n移動成功するとOK/失敗するとNGを表示\r\n右クリックした場合はcacheフォルダ直下以外の場合も移動'],
					['style.textAlign', 'center']
				]],
				[this.useFlvlist ? 'td' : 0, [
					[true, '　　保存フォルダ　　'],
					["width", '20%'],
					['style.whiteSpace', 'pre'],
					['style.textAlign', 'center'],
					['title', '動画の現在の保存フォルダ・規定の幅を超えた分は非表示\r\ntitle属性に全文あるのでマウスオーバーで表示可能']
				]],
				[this.useFlvlist ? 'td' : 0, [true, '：']],
				['td', [
					[true, '動画ID'],
					['title', 'cache済み動画のsmid(マウスオーバーでサムネ表示)'],
					['style.textAlign', 'center']
				]],
				['td', [true, '：']],
				['td', [
					[true, 'cacheタイトル (右クリックでファイル名変更)'],
					['title', 'cacheファイルのタイトル≠現在のニコニコでのタイトル']
				]]
			]);

			$A(help.getElementsByTagName('td')).each(function (obj) {
				if (obj.title) {
					obj.style.border = 'solid 1px #333';
				}
			});

			function make(n, smid, title, folder) {
				folder = folder || self.defaultFolderName;
				var elem = MakeElement(false, ['p', [
					['style.whiteSpace', 'pre'],
					['title', title]
				],
					[true, title]
				]);
				//	ここからタイトル変更用
				var titleChange = function () {
					var input = document.createElement('input');
					input.type = 'text';
					input.value = title;
					input.title = '空欄でデフォルト';
					input.style.width = elem.parentNode.offsetWidth + 'px';
					input.style.border = 'solid 1px black';
					input.onkeypress = function (evt) {
						evt = window.event || evt;
						if (evt.keyCode == 13 || evt.which == 13) {
							this.onblur();
						}
					};
					input.onblur = function () {
						this.onblur = null;
						var new_title = elem.firstChild.value;
						if (new_title != title) {
							new Ajax.Request("/cache/ajax_title?" + smid + (new_title != "" ? '-' + encodeURIComponent(new_title) : ""), {
								method: 'GET',
								asynchronous: false,
								onComplete: function (xhr) {
									title = xhr.responseText.match(/^OK (.+)$/) ? RegExp.$1 : "null";
									elem.innerHTML = title;
									// Flvlistの情報を更新
									self.updateCacheList(smid, 0, title);
								}
							});
						} else {
							elem.innerHTML = title;
						}
						elem.oncontextmenu = function () {
							titleChange();
							return false;
						}
					};
					elem.oncontextmenu = function () {};
					elem.replaceChild(input, elem.firstChild);
					elem.firstChild.focus();
					elem.firstChild.select();
					return false;
				};
				elem.oncontextmenu = titleChange;
				//	ここまで

				MakeElement(tbody, ['tr', ["className", "NCM_checked", "id", "NCM_" + smid],
					['td', ['style.textAlign', 'center'],
						['input', [
							['type', 'checkbox'],
							['className', 'NCM_checkbox'],
							['title', '一括移動時に移動する動画'],
							['checked', true],
							['onclick', function(){
								var check = this.checked;
								if(self.shiftDownNow && typeof self.last_checked == 'number'){
									if(self.last_checked > n) {
										var i = n;
										var e = self.last_checked;
									} else {
										var i = self.last_checked;
										var e = n;
									}
									var box = $(self.table).getElementsByClassName('NCM_checkbox');
									for (;i <= e; i++){
										if (!box[i].hasClassName("NCM_hidden")) {
											box[i].checked = check;
											box[i].parentNode.parentNode.className = check ? "NCM_checked" : "";
										}
									}
								}
								this.parentNode.parentNode.className = check ? "NCM_checked" : "";
								self.last_checked = n;
								self.allMoveButtonUpdate();
							}]
						]]
					],
					['td', ['style.textAlign', 'center'],
						['input', [
							['type', 'button'],
							['value', '移動'],
							['className', 'NCM_moveButton'],
							['title', '左クリックでcache直下のファイルのみ対象 \r\n/ 右クリックで全キャッシュフォルダ対象'],
							['onclick', function () {
								self.move(smid, true, this);
							}],
							['oncontextmenu', function () {
								self.move(smid, false, this);
								return false;
							}]
						]]
					],
					[self.useFlvlist ? 'td' : 0, ['width', '20%'],
						['p', [
							[true, folder],
							['style.height', '1.2em'],
							['style.overflow', 'hidden'],
							['style.wordBreak', 'break-all'],
							['title', folder]
						]]
					],
					[self.useFlvlist ? 'td' : 0, [true, '：']],
					['td', ['style.textAlign', 'right'],
						['a', [
							[true, smid],
							['href', 'http://www.nicovideo.jp/watch/' + smid],
							['onmouseout', function(){
								self.hideThumbImg(n);
							}],
							['onmouseover', function (e) {
								self.showThumbImg(smid, n, e);
							}]
						]],
						['img', [
							['src', 'http://res.nimg.jp/img/_.gif'],
							['className', 'NCM_Img',],
							['style.display', 'none'],
							['style.position', 'fixed'],
							['style.border', 'solid 2px #333'],
							['width', '130'],
							['height', '100']
						]]
					],
					['td', [true, '：']],
					['td', [],
						[elem]
					]
				]);
			}
			for (var j = 0, len = smid.length; j < len; ++j) {
				make(j, smid[j][0], smid[j][1], smid[j][2]);
			}
		},
		filterVideos: function(event, sbox){
			if (event.keyCode != 13) return true;
			var word = sbox.value;
			/*
			var smid_cached_default = this.smid_cached.slice(0);
			if (word) for (var i = 0; i < this.smid_cached.length; i++) {
				if (!(this.smid_cached[i][0].match(word) || this.smid_cached[i][1].match(new RegExp(word, "i")))) {
					this.smid_cached.splice(i, 1);
					i--;
				}
			}
			this.appendPanelTable();
			this.allMoveButtonUpdate();
			this.smid_cached = smid_cached_default;
			*/
			for (var i = 0; i < this.smid_cached.length; i++) {
				if (word === "" || this.smid_cached[i][0].match(word) || this.smid_cached[i][1].match(new RegExp(word, "i")) || this.smid_cached[i][2].match(new RegExp(word, "i"))) {
					$("NCM_" + this.smid_cached[i][0]).show().addClassName("NCM_checked").getElementsByTagName('input')[0].removeClassName("NCM_hidden").checked=true;
				} else {
					$("NCM_" + this.smid_cached[i][0]).hide().removeClassName("NCM_checked").getElementsByTagName('input')[0].addClassName("NCM_hidden").checked=false;
				}
			}
			this.allMoveButtonUpdate();
		},
		resize: function(){
			var CPanel = this.ControlPanel;
			if(!CPanel || !CPanel.offsetHeight) return;
			CPanel.style.marginTop = '-' + this.size() / 2 + 'px';
			CPanel.style.height = this.size() + 'px';
			this.table.style.height = CPanel.offsetHeight - $(this.top).offsetHeight - 5 + 'px';
		},
		load: function () {
			var self = this;
			this.getData(function () {
				self.getCached();
				self.makePanel();
			});
			this.usePopThumb = !!window.popThumb && this.usePopThumb;
		},
		__empty: function () {}
	};


	/*	要素追加用関数(elm「親要素」, arg[追加要素, 属性, 子要素(argと同じ形式・複数可能)])
	 親要素はID名かエレメントを指定。
	 返り値は追加した要素（親直下・arg[0]）
	 親要素elmをfalseにすると追加ではなく作成のみを行い、それを返す
	 追加要素は"div"や"p"などの文字列でも、すでにあるエレメントでもok
	 追加要素をtrueに指定すると、文字列をcreateTextNodeして追加。(elm, [true, 'test'])
	 属性部分でも文字列ではなく、trueにするとcreateTextNodeで追加(elm, ['p', [true, 'test']])
	 属性部分は２個づつ配列でくくっても、くくらなくてもOK
	 http://jsbeautifier.org/?tabsize=1で整形したときに見やすくなるようになってます。
	 */
	function MakeElement(elm, arg) {
		if(elm === 0) return;
		try {
			var tag = arg[0];
			var attr = arg[1];
			var child = arg.slice(2);
			elm = (typeof elm === 'string') ? document.getElementById(elm) : elm;
			if (tag) {
				if (tag === true) {
					attr = String(attr);
					elm.appendChild(document.createTextNode(attr));
				} else {
					tag = (typeof tag == 'string') ? document.createElement(tag) : tag;
						if (attr && attr.length) {
							if (typeof attr[0] == 'string' || attr[0] === true) {
								for (var i = 1, len = attr.length; i < len; i = i + 2) {
									if (attr[i - 1] === true) {
										attr[i] = String(attr[i]);
										tag.appendChild(document.createTextNode(attr[i]));
									} else {
										eval('tag.' + attr[i - 1] + '=attr[i]');
									}
								}
							} else {
								for (var i = 0, len = attr.length; i < len; i++) {
									if (attr[i][0] === true) {
										tag.appendChild(document.createTextNode(attr[i][1]));
									} else {
										eval('tag.' + attr[i][0] + '=attr[i][1]');
									}
								}
							}
						}
					if(elm){
						elm = elm.appendChild(tag);
					} else {
						elm = tag;
					}
					if (child && child.length) {
						for (var n = 0, len = child.length; n < len; n++) {
							MakeElement(elm, child[n]);
						}
					}
				}
			}
			return elm;
		} catch (e) {
			alert('MakeElement' + e);
		}
	}
	//	↓jsをload時にflvList.jsonを受信。無駄な気がするのでコメントアウトしてあります。
	//NicoCacheMove.getData();
	
	// prototype.jsが使えないページがあるので全部自前で用意した
	// 各種関数
	function addEvent(obj, type, func, useCapture){
		if (typeof window.addEventListener === "function") {
			obj.addEventListener(type, func, !!useCapture );
		} else if (window.attachEvent) {
			obj.attachEvent('on' + type, func);
		}
	}
	
	function $(B) {
		if (typeof B === "string") {
			B = document.getElementById(B);
		}
		if (!B._MoveFolderExtend) {
			B._MoveFolderExtend = true;
			B.remove = function(){
				B.parentNode.removeChild(B);
			};
			B.show = function(){
				B.style.display = "";
				return B;
			};
			B.hide = function(){
				B.style.display = "none";
				return B;
			};
			B.toggle = function(){
				var isVisible = B.style.display !== "none";
				B.style.display = isVisible ? "none" : "";
				return B;
			};
			B.addClassName = function(cn){
				var oldCN = B.className;
				B.className = oldCN.replace("(^| )" + cn + "( |$)", "") + " " + cn;
				return B;
			};
			B.removeClassName = function(cn){
				var oldCN = B.className;
				B.className = oldCN.replace("(^| )" + cn + "( |$)", "");
				return B;
			};
			B.hasClassName = function(cn){
				return (new RegExp("(^| )" + cn + "( |$)")).test(B.className);
			};
			B._getElementsByTagName = B._getElementsByTagName || B.getElementsByTagName;
			B.getElementsByTagName = function (tagname){
				var elems = B._getElementsByTagName.apply(B, arguments);
				resElems = [];
				for (var i = 0, len = elems.length; i < len; i++) {
					resElems[i] = $(elems[i]);
				}
				return resElems;
			};
			B._getElementsByClassName = B._getElementsByClassName || B.getElementsByClassName;
			B.getElementsByClassName = function (tagname){
				var elems = B._getElementsByClassName.apply(B, arguments);
				resElems = [];
				for (var i = 0, len = elems.length; i < len; i++) {
					resElems[i] = $(elems[i]);
				}
				return resElems;
			};
		}
		return B;
	}
	function $A(elems) {
		return {
			each : function(fn){
				for (var i = 0, len = elems.length; i < len; i++) {
					fn($(elems[i]));
				}
			}
		};
	}
	var Ajax = {
		Request: function (url, obj) {
			var argFunc = obj.onComplete;
			var Async = obj.asynchronous;
			if (obj.parameters) url += "?" + obj.parameters;
			var httpObj = false;
			if (window.XMLHttpRequest) {
				// Firefox, Opera など IE8も対応済み？
				httpObj = new XMLHttpRequest();
			} else if (window.ActiveXObject) {
				// IE
				try {
					httpObj = new ActiveXObject('Msxml2.XMLHTTP');
				} catch (e) {
					httpObj = new ActiveXObject('Microsoft.XMLHTTP');
				}
			}
			httpObj.abort();
			httpObj.open('GET', url, !!Async);
			httpObj.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT");
			if (navigator.userAgent.toLowerCase().indexOf("msie") == -1) { //　IE以外=firefox等
				httpObj.onload = function () {
					func();
				}
			} else {
				httpObj.onreadystatechange = function () {
					if (httpObj.readyState == 4) {
						func();
					}
				}
			}
			httpObj.send(null);
			
			function func(){
				var json = null;
				try {
					json = window.JSON.parse(httpObj.responseText);
				} catch (e) {}
				argFunc(httpObj, json);
			}
		}
	};
	addEvent(window, 'resize', function(){
		NicoCacheMove.resize();
	});
	
	addEvent(document.body, 'keydown', function(evt){
		evt = evt || window.event;
		if(evt.keyCode === 16 || evt.which === 16){
			NicoCacheMove.shiftDownNow = true;
		}
	});
	addEvent(document.body, 'keyup', function(){
		NicoCacheMove.shiftDownNow = false;
	});
	addEvent(window, 'blur', function(){
		NicoCacheMove.shiftDownNow = false;
	});
	NicoCacheMove.shiftDownNow = false;
	
})();